
#include "arc_disp_param.h"
#include "arc_tcon.h"
#include "arc_pgu.h"
#include <linux/autoconf.h>
/*--------------------------------------------------------------------------------*/

#define ID "ARC PGU FB"

#define PGU_BASEADDR 				0xC0FC8000 // FIXME take this from config or boot parameter
#define YPbPr_BASEADDR 				0xC0FC1300
#define TV_BASEADDR 				0xC0FC1500

#define DEFAULT_ALIGN_SIZE 			32
#define BUF_ALIGN(x, alignment) 	((x) & ~alignment)

/* Flowbee@*/
static sky_ypbpr *ypbpr_ptr	= (sky_ypbpr*) YPbPr_BASEADDR;
static sky_tv *tv_ptr = (sky_tv*) TV_BASEADDR;
static arc_pgu *pgu_ptr = (arc_pgu *) PGU_BASEADDR;

static unsigned long val = 0;
static volatile unsigned long vtval; 	
unsigned short OUTPUT_XRES;
unsigned short OUTPUT_YRES;
unsigned long YUVBase;
unsigned long YUVBufSize;
unsigned long YBufSize;
unsigned long UVBufSize;
extern unsigned int FBBaseAddr;
extern int DispNo;
extern void* memset(void* s, int c, size_t n);
int set_yuv_pointer(void);

/*--------------------------------------------------------------------------------*/
/*
 *	SPI functions for T-CON control.
 */
static void delay(unsigned long ns)
{
	do { 
		unsigned long _x; 
		for(_x=0; _x<ns; _x++){
			__asm__ __volatile__("nop");
		} 
	} while(0);	
}

#if 0
//**	GPIO function.
/*--------------------------------------------------------------------------------*/
void set_gpio_bit(unsigned long _addr, unsigned long _mask)
{
	val = GIO_R32(_addr);
	val = GIO_R32(_addr);
	val |= _mask;
	GIO_W32(_addr, val);
}

/*--------------------------------------------------------------------------------*/
unsigned long get_gpio_bit(unsigned long _addr, unsigned long _mask)
{
	val = GIO_R32(_addr);
	val = GIO_R32(_addr);
	return (((val & _mask) > 0)? 1: 0);
}

/*--------------------------------------------------------------------------------*/
void clear_gpio_bit(unsigned long _addr, unsigned long _mask)
{
	val = GIO_R32(_addr);
	val = GIO_R32(_addr);
	val &= ~(_mask);
	GIO_W32(_addr, val);
}
#endif

/*--------------------------------------------------------------------------------*/
#if 0	//-- Himax 8817A

#define END_CMD			(-1)
int HimaxTCONCmd[][2]=
{	/* Addr, Val */
	{  0x00, 0xCF  },	// interface: 601 port0, resolution: 1440x234 stripe.
	{  0x01, 0x52  },		
	{  0x02, 0xFF  },
	{  0x03, 0x00  },	
	{  0x04, 0x00  },
	{  0x05, 0x00  },
	{  0x06, 0x48  },
	{  0x07, 0x06  },
	{  0x08, 0x13  },
	{  0x09, 0x1C  },
	{  0x0A, 0x11  },
	{  0x0B, 0x15  },
	{  0x0C, 0x0A  },	
	{  0x0D, 0x0F  },
	{  0x0E, 0x16  },
	{  0x0F, 0x44  },	
	{  0x10, 0x13  },		
	{  END_CMD, END_CMD  },		
};

/*----------------------------------------------------------------------------*/
static void spi_start(unsigned char rw)
{
	/* Set SCL, SDI output */
	SPI_SCL_OUT;	
	SPI_SDI_OUT;
	SPI_CS_OUT;
	/* Set SCL to high */
	SPI_CS_HI;	
	SPI_SDI_HI;
	SPI_SCL_HI;
	delay(SPI_START_TIME);
	/* Set SPI read/write */
	SPI_SCL_LO;
	if (rw == SPI_WRITE){
		SPI_SDI_LO;
	}
	else{
		SPI_SDI_HI;
	}

	delay(SPI_CLOCK_TIME);
	SPI_SCL_HI;
	delay(SPI_CLOCK_TIME);
}

/*----------------------------------------------------------------------------*/
static void spi_stop(void)
{
	SPI_SCL_LO;
	delay(SPI_CLOCK_TIME);
	SPI_SCL_HI;
	delay(SPI_CLOCK_TIME);

	SPI_SDI_HI;
	SPI_CS_LO;		
	delay(SPI_STOP_TIME);
}

/*----------------------------------------------------------------------------*/
static void spi_write(unsigned char reg_val, unsigned char bit_cnt)
{
	unsigned int i;
	
	i = (1 << (bit_cnt-1));
	
	for ( ; i>0; i>>=1 ){

		SPI_SCL_LO;

		if ( (i&reg_val) == 0 ){
			SPI_SDI_LO;
		}
		else{
			SPI_SDI_HI;
		} 

		delay(SPI_CLOCK_TIME);
		
		SPI_SCL_HI;
		delay(SPI_CLOCK_TIME);
	}
}

/*----------------------------------------------------------------------------*/
static void SpiWriteCmd(unsigned char reg_addr, unsigned char reg_val)
{
	unsigned char spi_addr = reg_addr;
	unsigned char spi_val = reg_val;
	
	spi_start(SPI_WRITE);
	spi_write(spi_addr, SPI_ADDR_CNT);
	spi_write(spi_val, SPI_DATA_CNT);
	spi_stop();
}

/**
 * InitHimax8817A() - Init the Himax 8817A T-CON.
 * 
 * Init the Himax 8817A T-CON for the CPT CLAA070WA03 TFT LCD.
 **/
static void InitHimax8817A(void)
{
	int i = 0;
	/* Writing command to the T-CON via the SPI interface. */
	while(HimaxTCONCmd[i][0] != END_CMD){
		SpiWriteCmd((unsigned char)HimaxTCONCmd[i][0], (unsigned char) HimaxTCONCmd[i][1]);
		i ++;
	}
}

#endif	//-- Himax 8817A

/* -------------------------------------------------------------------------- */
static int display_index = 0;
struct known_displays *p_current_display;
/*-----------------------------------------------------------------------*/
int arc_pgufb_reinit(void)
{
	unsigned long freq;
	unsigned long tmpsize;
	int ret_val = 0;
	unsigned long reg_val;
	unsigned long change_cnt;

	p_current_display = &displays[display_index];

	/* Set 1080I PLL divider and display clock. */
	//-- Get PLL divider register value.
	freq = 0;
	freq = YPBPR_1080I_REG;
	while (freq == 0){
		freq = YPBPR_1080I_REG;
	}	
	freq &= ~(YPBPR_LOCK_MASK);
	freq |= YPBPR_LOCK_PATTERN;

	//-- Unlock display register.
	tmpsize = 0;
	tmpsize |= LOCK_PATTERN;
	if (display_index == DISP_HDTV){
		/* PLL divider (divide by 1). */
		freq &= ~(VIDEO_SEL_DIV2_MASK);
		YPBPR_1080I_REG = freq;
		YPBPR_1080I_REG = freq;		
		/* Display clock (74.25MHz). */
		tmpsize |= DISP_CLK_74250KHZ;
		DISP_CLK_REG = tmpsize;
		DISP_CLK_REG = tmpsize;
	}
	else{
		/* PLL divider (divide by 2). */
		freq |= (VIDEO_SEL_DIV2_MASK);
		YPBPR_1080I_REG = freq;
		YPBPR_1080I_REG = freq;		
		/* Display clock (27MHz). */
		tmpsize |= DISP_CLK_27MHZ;
		DISP_CLK_REG = tmpsize;
		DISP_CLK_REG = tmpsize;
	}

	if ( (display_index == DISP_NTSC) || (display_index == DISP_HIMAX_NTSC) ){
	//-- Set to NTSC
		#ifdef CONFIG_ARCPGU_TV_OUT_YPBPR // Flowbee 2008-04-22
		reg_val = ypbpr_ptr->disp_ctrl;
		reg_val &= ~(YPBPR_CTRL_REG_ACTIVE_MODE_MASK);
		reg_val |= (ACTIVE_MODE_NTSC);
		ypbpr_ptr->disp_ctrl = reg_val;

		#else	//~CONFIG_ARCPGU_TV_OUT_YPBPR // Flowbee 2008-04-22
		reg_val = ypbpr_ptr->disp_ctrl;
		reg_val &= ~(YPBPR_CTRL_REG_ACTIVE_MODE_MASK);
		reg_val |= (ACTIVE_MODE_NTSC);
		ypbpr_ptr->disp_ctrl = reg_val;
			
		tv_ptr->fmt_ctrl = TVE_NTSC_M;				
		reg_val = tv_ptr->fmt_ctrl;
		while (reg_val != TVE_NTSC_M){
			tv_ptr->fmt_ctrl = TVE_NTSC_M;	
			reg_val = tv_ptr->fmt_ctrl;
		}
		#endif
	}
	else if ( (display_index == DISP_PAL) || (display_index == DISP_HIMAX_PAL) ){
	//-- Set to PAL
		#ifdef CONFIG_ARCPGU_TV_OUT_YPBPR // Flowbee 2008-04-22
		reg_val = ypbpr_ptr->disp_ctrl;
		reg_val &= ~(YPBPR_CTRL_REG_ACTIVE_MODE_MASK);
		reg_val |= (ACTIVE_MODE_PAL);
		ypbpr_ptr->disp_ctrl = reg_val;
		
		#else
		reg_val = ypbpr_ptr->disp_ctrl;
		reg_val &= ~(YPBPR_CTRL_REG_ACTIVE_MODE_MASK);
		reg_val |= (ACTIVE_MODE_PAL);
		ypbpr_ptr->disp_ctrl = reg_val;
			change_cnt = 0;
		tv_ptr->fmt_ctrl = TVE_PAL_B_D_G_H_I;
		reg_val = tv_ptr->fmt_ctrl;
		while (reg_val != TVE_PAL_B_D_G_H_I){
			tv_ptr->fmt_ctrl = TVE_PAL_B_D_G_H_I;
			reg_val = tv_ptr->fmt_ctrl;
			change_cnt ++;
			if(change_cnt > 200){
				//__puts("\n -- PAL Error !! -- ");
				break;
			}
		}
		#endif
	}
	else if (display_index == DISP_HDTV){
	//-- Set to HDTV	
		reg_val = ypbpr_ptr->disp_ctrl;
		reg_val &= ~(YPBPR_CTRL_REG_ACTIVE_MODE_MASK);
		reg_val |= (ACTIVE_MODE_1080I_30FPS);
		ypbpr_ptr->disp_ctrl = reg_val;
	}		

	return ret_val;
}

/*-----------------------------------------------------------------------*/
int arc_pgufb_init(void)
{
	unsigned long freq;
	unsigned long tmpsize;
	int ret_val = 0;
	unsigned long reg_val;
	unsigned long change_cnt;

//	__puts("\n -- init pgufb start --\n");
	
	//-- Flowbee 2008-04-23
//	#elif (CONFIG_SKY_IO_FOXCONN_COMPANY_V1 || CONFIG_LT_TV_SWITCH)	
	#if (defined(TV_SWITCH_MOD) && defined(TV_SWITCH_INTERFACE))
	// set gpio input to get display interface (YPbPr/CVBS)
	GPIO_INPUT(SKY_GPIO_DIR, (1 << TV_SWITCH_INTERFACE));
	GPIO_ST(SKY_GPIO_DATA, (1 << TV_SWITCH_INTERFACE));	
	if(vtval == 0){
		// CVBS -> check PAL(1) / NTSC(0)
		GPIO_INPUT(SKY_GPIO_DIR, (1 << TV_SWITCH_MOD));
		GPIO_ST(SKY_GPIO_DATA, (1 << TV_SWITCH_MOD));	
		display_index = (vtval == 0)? DISP_NTSC: DISP_PAL;
	}
	else{
		// YPbPr -> set to HDTV
		display_index = DISP_HDTV;
	}
//	#if ( CONFIG_SKY_IO_FS_COMPANY_V2 || CONFIG_SKY_IO_WINACCORD_COMPANY_V1)
	#elif defined(TV_SWITCH_INTERFACE)
	// set gpio input
	GPIO_INPUT(SKY_GPIO_DIR, (1 << TV_SWITCH_INTERFACE));
	GPIO_ST(SKY_GPIO_DATA, (1 << TV_SWITCH_INTERFACE));
	display_index = (vtval == 0)? DISP_NTSC: DISP_HDTV;
	
	#else
	display_index = CONFIG_ARCPGU_DISPTYPE;

	#endif

	p_current_display = &displays[display_index];

	OUTPUT_XRES = p_current_display->xres;
	OUTPUT_YRES = p_current_display->yres;	

	YUVBase = (OUTPUT_XRES * OUTPUT_YRES * 2 * CONFIG_ARCPGU_RGBBUFS);
	//-- YCbCr 4:2:0
	tmpsize = (OUTPUT_XRES * OUTPUT_YRES);
	YBufSize = BUF_ALIGN((tmpsize + DEFAULT_ALIGN_SIZE), DEFAULT_ALIGN_SIZE);
	tmpsize = ( (OUTPUT_XRES/2) * (OUTPUT_YRES/2) );
	UVBufSize = BUF_ALIGN((tmpsize + DEFAULT_ALIGN_SIZE), DEFAULT_ALIGN_SIZE);
	YUVBufSize = YBufSize + UVBufSize + UVBufSize;

	//-- Turn off video DAC. (1: power off, 0: power on)
	VDAC_CTRL_REG |= VDAC_EN_MASK;

	if ( (display_index == DISP_NTSC) || (display_index == DISP_PAL) 
		|| (display_index == DISP_HIMAX_NTSC) || (display_index == DISP_HIMAX_PAL)
		|| (display_index == DISP_HDTV) ){
		/* TV settings. */
		#if CONFIG_TERAWINS_TCON
		//-- Turn off pwm(backlight).
		tcon_set_pwm(0);
		#endif

		/* Set video output mux for TV or LCD. */
		freq = 0;
		freq = DISP_MUX_REG;
		while (freq == 0){
			freq = DISP_MUX_REG;
		}
		freq &= ~(LOCK_PATTERN_MASK);
		freq |= LOCK_PATTERN;
		//-- Set TV out.
		freq &= ~(LCD_SEL_MASK);
		DISP_MUX_REG = freq;
		DISP_MUX_REG = freq;

		/* Set 1080I PLL divider and display clock. */
		//-- Get PLL divider register value.
		freq = 0;
		freq = YPBPR_1080I_REG;
		while (freq == 0){
			freq = YPBPR_1080I_REG;
		}	
		freq &= ~(YPBPR_LOCK_MASK);
		freq |= YPBPR_LOCK_PATTERN;

		//-- Unlock display register.
		tmpsize = 0;
		tmpsize |= LOCK_PATTERN;
		if (display_index == DISP_HDTV){
			/* PLL divider (divide by 1). */
			freq &= ~(VIDEO_SEL_DIV2_MASK);
			YPBPR_1080I_REG = freq;
			YPBPR_1080I_REG = freq;		
			/* Display clock (74.25MHz). */
			tmpsize |= DISP_CLK_74250KHZ;
			DISP_CLK_REG = tmpsize;
			DISP_CLK_REG = tmpsize;				
		}
		else{
			/* PLL divider (divide by 2). */
			freq |= (VIDEO_SEL_DIV2_MASK);
			YPBPR_1080I_REG = freq;
			YPBPR_1080I_REG = freq;		
			/* Display clock (27MHz). */
			tmpsize |= DISP_CLK_27MHZ;
			DISP_CLK_REG = tmpsize;
			DISP_CLK_REG = tmpsize;						
		}

		#if 0
		/* Init himax T-CON. */
		if ( (display_index == DISP_HIMAX_NTSC) || (display_index == DISP_HIMAX_PAL)
			|| (display_index == DISP_HIMAX_480240_TFT) ){
			InitHimax8817A();
		}
		#endif

		if ( (display_index == DISP_NTSC) || (display_index == DISP_HIMAX_NTSC) ){
		//-- Set to NTSC
			#ifdef CONFIG_ARCPGU_TV_OUT_YPBPR // Flowbee 2008-04-22
			reg_val = ypbpr_ptr->disp_ctrl;
			reg_val &= ~(YPBPR_CTRL_REG_ACTIVE_MODE_MASK);
			reg_val |= (ACTIVE_MODE_NTSC);
			ypbpr_ptr->disp_ctrl = reg_val;

			#else	//~CONFIG_ARCPGU_TV_OUT_YPBPR // Flowbee 2008-04-22
			reg_val = ypbpr_ptr->disp_ctrl;
			reg_val &= ~(YPBPR_CTRL_REG_ACTIVE_MODE_MASK);
			reg_val |= (ACTIVE_MODE_NTSC);
			ypbpr_ptr->disp_ctrl = reg_val;
			
			tv_ptr->fmt_ctrl = TVE_NTSC_M;				
			reg_val = tv_ptr->fmt_ctrl;
			while (reg_val != TVE_NTSC_M){
				tv_ptr->fmt_ctrl = TVE_NTSC_M;	
				reg_val = tv_ptr->fmt_ctrl;
			}
			#endif
		}
		else if ( (display_index == DISP_PAL) || (display_index == DISP_HIMAX_PAL) ){
		//-- Set to PAL
			#ifdef CONFIG_ARCPGU_TV_OUT_YPBPR // Flowbee 2008-04-22
			reg_val = ypbpr_ptr->disp_ctrl;
			reg_val &= ~(YPBPR_CTRL_REG_ACTIVE_MODE_MASK);
			reg_val |= (ACTIVE_MODE_PAL);
			ypbpr_ptr->disp_ctrl = reg_val;
			
			#else
			reg_val = ypbpr_ptr->disp_ctrl;
			reg_val &= ~(YPBPR_CTRL_REG_ACTIVE_MODE_MASK);
			reg_val |= (ACTIVE_MODE_PAL);
			ypbpr_ptr->disp_ctrl = reg_val;

			change_cnt = 0;
			tv_ptr->fmt_ctrl = TVE_PAL_B_D_G_H_I;
			reg_val = tv_ptr->fmt_ctrl;
			while (reg_val != TVE_PAL_B_D_G_H_I){
				tv_ptr->fmt_ctrl = TVE_PAL_B_D_G_H_I;
				reg_val = tv_ptr->fmt_ctrl;
				//flush_dcache_range(&(tv_ptr->fmt_ctrl), &(tv_ptr->fmt_ctrl) + 4);
				//FB_MSG("\n %08p = %08lx", &(tv_ptr->fmt_ctrl), tv_ptr->fmt_ctrl);
				change_cnt ++;
				if(change_cnt > 100){
					//__puts("\nPAL Error !! \n");
					change_cnt = 0;
					//-- Set to HDTV output and then set to PAL
					//Set to HDTV	
					display_index = DISP_HDTV;
					arc_pgufb_reinit();
					delay(0x100);
					//-- Set to PAL
					display_index = DISP_PAL;
					arc_pgufb_reinit();
					delay(0x100);
					reg_val = tv_ptr->fmt_ctrl;
				}
			}
			#endif
		}
		else if (display_index == DISP_HDTV){
		//-- Set to HDTV	
			reg_val = ypbpr_ptr->disp_ctrl;
			reg_val &= ~(YPBPR_CTRL_REG_ACTIVE_MODE_MASK);
			reg_val |= (ACTIVE_MODE_1080I_30FPS);
			ypbpr_ptr->disp_ctrl = reg_val;
		}		

		/* Select YPbPr or CVBS (S-Video) output. */
		//--Flowbee 2007-07-31
		ypbpr_ptr->disp_ctrl &= ~(CVBS_YPBPR_MASK);
		#ifdef CONFIG_ARCPGU_TV_OUT_YPBPR //wschen 2007-06-06 
		ypbpr_ptr->disp_ctrl |= YPBPR_EN;
		#else
		ypbpr_ptr->disp_ctrl |= (display_index == DISP_HDTV) ? (YPBPR_EN) : (CVBS_EN);
		#endif
	}
	else{
	/* LCD settings. */
    //QMI 5V PWR------------------
        #if CONFIG_SKY_IO_QMI_COMPANY_V2
        QMI_LCD_OUTPUT;
        QMI_LCD_LO;
        E5V_OUTPUT
        E5V_HI       
        #endif
    //----------------------------
		#if CONFIG_FASHION_STAR
		BL_OUT;
		BL_OFF;
		#endif          

		#if CONFIG_TERAWINS_TCON
		if( init_tcon() != 0 ){
			if(init_tcon() != 0){
				ret_val = -1;
			}
		}
		//-- Turn off Terawins backlight.
		tcon_backlight_on_off(0);
		//-- Turn off osd function.
//		tcon_set_osd_cmd(OSD_CTRL, 0x00);	// turn off osd, set to char mode.
		//-- Disable input data path.
		tcon_on_off(0);		
		tcon_pwm_on_off(0);		
		#endif

		/* Set video output mux for TV or LCD */
		freq = 0;
		freq = DISP_MUX_REG;
		while (freq == 0){
			freq = DISP_MUX_REG;
		}
		freq &= ~(LOCK_PATTERN_MASK);
		freq |= LOCK_PATTERN;

		/* Set LCD out. */
		freq |= (LCD_SEL_MASK);
		DISP_MUX_REG = freq;
		DISP_MUX_REG = freq;

		pgu_ptr->clk_cfg = p_current_display->clkcontrol;		

		/* Setting the active size of the LCD panel. */
		pgu_ptr->disp_dim = ENCODE_PGU_DIMS((p_current_display->xres-1), (p_current_display->yres-1));	
		
		/* Setting the sync. signal for the specified LCD panel. */
		pgu_ptr->hsync_cfg = p_current_display->hsync;
		pgu_ptr->vsync_cfg = p_current_display->vsync;
	
		pgu_ptr->centreoffsets = 0;

		/* Reset pgu control register. */
		pgu_ptr->statctrl = 0;
		pgu_ptr->statctrl |= (STATCTRL_CONT_B_MASK | STATCTRL_PIX_FMT_YUV420 | p_current_display->control);
	}

	/* Setting frame dimension and frame stride. */
	pgu_ptr->frm_dim 	= ENCODE_PGU_DIMS( (OUTPUT_XRES-1), (OUTPUT_YRES-1));
	pgu_ptr->stride 	= OUTPUT_XRES;
	pgu_ptr->cru_stride = OUTPUT_XRES >> 1;
	pgu_ptr->crv_stride = OUTPUT_XRES >> 1;
	pgu_ptr->cru_frm_st = BUF_ALIGN((tmpsize + DEFAULT_ALIGN_SIZE), DEFAULT_ALIGN_SIZE);
	pgu_ptr->crv_frm_st = BUF_ALIGN((pgu_ptr->cru_frm_st + (tmpsize >> 2) + DEFAULT_ALIGN_SIZE), DEFAULT_ALIGN_SIZE);
	/* Setting input data in YUV format. */
	pgu_ptr->statctrl &= ~(STATCTRL_PIX_FMT_MASK);
	pgu_ptr->statctrl |= (STATCTRL_PIX_FMT_YUV420);

	ypbpr_ptr->ycbcr_stride = (OUTPUT_XRES << 16) | (OUTPUT_XRES >> 1);	

	/* OSD configurations for LCD module. */
	pgu_ptr->statctrl &= ~(STATCTRL_OL_FMT_MASK);
	pgu_ptr->statctrl |= STATCTRL_OL_FMT_RGBA5551;
	pgu_ptr->statctrl &= ~(STATCTRL_OL_VAL_MASK);
	pgu_ptr->statctrl |= STATCTRL_OL_VAL;	
	pgu_ptr->ol_frm_st = FBBaseAddr;
	pgu_ptr->ol_stride = p_current_display->xres * 2;
	pgu_ptr->ol_scn_line = ENCODE_PGU_DIMS((0), (p_current_display->yres-1));
	pgu_ptr->ol_col_key = 0;
	/* OSD configurations for TV module. */
	ypbpr_ptr->disp_ctrl &= ~(YPBPR_CTRL_REG_OL_FMT_MASK);
	ypbpr_ptr->disp_ctrl |= (OL_FMT_ARGB1555);	
	ypbpr_ptr->rgb_addr = FBBaseAddr;
	ypbpr_ptr->rgb_stride = ((p_current_display->xres * 2) | (STATCTRL_OL_VAL >> 12));
	ypbpr_ptr->rgb_range = ENCODE_PGU_DIMS((1), (p_current_display->yres));

	return ret_val;
}

/* -------------------------------------------------------------------------- */
int set_yuv_pointer(void)
{
	unsigned long _buf_addr;

	_buf_addr = FBBaseAddr + YUVBase + (YUVBufSize * DispNo);

	pgu_ptr->frm_start 	= _buf_addr;
	pgu_ptr->frm_dim 	= ENCODE_PGU_DIMS((OUTPUT_XRES-1), (OUTPUT_YRES-1));
	pgu_ptr->stride 	= OUTPUT_XRES;
	pgu_ptr->cru_stride = OUTPUT_XRES >> 1;
	pgu_ptr->crv_stride = OUTPUT_XRES >> 1;
	pgu_ptr->cru_frm_st = BUF_ALIGN((YBufSize + DEFAULT_ALIGN_SIZE), DEFAULT_ALIGN_SIZE);
	pgu_ptr->crv_frm_st = BUF_ALIGN((YBufSize + UVBufSize + DEFAULT_ALIGN_SIZE), DEFAULT_ALIGN_SIZE);
	/* Set to display YUV data. */
	pgu_ptr->statctrl &= ~(STATCTRL_PIX_FMT_MASK);
	pgu_ptr->statctrl |= (STATCTRL_PIX_FMT_YUV420);

	ypbpr_ptr->y_addr 	= _buf_addr;
	ypbpr_ptr->cb_addr	= BUF_ALIGN((_buf_addr + YBufSize + DEFAULT_ALIGN_SIZE), DEFAULT_ALIGN_SIZE);
	ypbpr_ptr->cr_addr	= BUF_ALIGN((_buf_addr + YBufSize + UVBufSize + DEFAULT_ALIGN_SIZE), DEFAULT_ALIGN_SIZE);
	ypbpr_ptr->ycbcr_stride = (OUTPUT_XRES << 16) | (OUTPUT_XRES >> 1);	

	return 0;
}

/* -------------------------------------------------------------------------- */	

extern int find_brightness_contrast(unsigned char *_bright, unsigned char *_cont);
extern int new_find_brightness_contrast(unsigned char *_bright, unsigned char *_cont);
extern void set_default_brightness_contrast(void);
extern unsigned char brightness, contrast;

int PGU_Enable(void)
{
	unsigned long blk_stripe;
	unsigned long dim_w, dim_h;

	/* Setup black stripe.*/
	if ( (display_index == DISP_NTSC) || (display_index == DISP_PAL)
		|| (display_index == DISP_HIMAX_NTSC) || (display_index == DISP_HIMAX_PAL) 
		|| (display_index == DISP_HDTV)){
		/* get the frame dimension.(width and height). */
		dim_w = (pgu_ptr->frm_dim & FRM_DIM_REG_FRM_WTH_MASK) + 1;
		dim_h = ((pgu_ptr->frm_dim >> 16) & FRM_DIM_REG_FRM_LNS_MASK) + 1;
		/* check frame dimensions(width). */
		if (p_current_display->xres > dim_w){
			blk_stripe = (p_current_display->xres - dim_w) >> 1;
			ypbpr_ptr->HBlank = ((blk_stripe << 16) | (blk_stripe));
		}
		else{
			ypbpr_ptr->HBlank = 0;
		}
		/* check frame dimensions(height). */
		if (p_current_display->yres > dim_h){
			blk_stripe = (p_current_display->yres - dim_h) >> 1;
			//--Set vertical black stride be multiple of 2.
			if( (blk_stripe%2) == 1 ){
				blk_stripe += 1;
			}
			ypbpr_ptr->VBlank = ((blk_stripe << 16) | (blk_stripe));
		}
		else{
			ypbpr_ptr->VBlank = 0;
		}
		//-- Flowbee 20071211 Turn off TV output for ABO.
		#if CONFIG_SKY_IO_ABO_COMPANY_V2
			return 0;
		#endif
		#if CONFIG_LT_TV_SWITCH
			return 0;
		#endif
		
		//-- Turn on video DAC. (1: power off, 0: power on)
		VDAC_CTRL_REG &= ~(VDAC_EN_MASK);
	
		/* Enable TV module. */
		//--Flowbee 2007-07-31
		ypbpr_ptr->disp_ctrl |= YPBPR_CTRL_REG_MODULE_EN_MASK;
	}
	else{	     
		/* Enable LCD output */
		pgu_ptr->statctrl |= STATCTRL_REG_DISP_EN_MASK;
		
		#if CONFIG_SKY_IO_QMI_COMPANY_V1
			E5V_OUTPUT;
			E5V_HI;								// enable 5V power               
			set_qmi_blue_led();						// set the blue led
			set_lcd_on();							// set lcd enable               
			//set brightness use two styles of AD5247 IIC address
			if(set_qmi_brightness(QMI_AD5247_ADDR_2E, 12))
			{
				set_qmi_brightness(QMI_AD5247_ADDR_5C, 52);
			}
		#endif // CONFIG_SKY_IO_QMI_COMPANY_V1

		#if CONFIG_SKY_IO_QMI_COMPANY_V2	
			QMI_BL_OUTPUT;
			QMI_BL_HI;							// turn on backlight
		#endif //CONFIG_SKY_IO_QMI_COMPANY_V2	
	}
	/* Flowbee@960310 - Turn on LCD back light. */
	if ( (display_index != DISP_NTSC) && (display_index != DISP_PAL) && (display_index != DISP_HDTV)){
		#if CONFIG_TERAWINS_TCON
			#if CONFIG_SKY_SPINOR_DRIVER
				//-- Flowbee 2008-04-08
				//if(find_brightness_contrast(&brightness, &contrast) == -1){
				//	return -1;
				//}
				if(new_find_brightness_contrast(&brightness, &contrast) == -1){
					return -1;
				}
				tcon_set_contrast(contrast);
				//-- Enable terawins output data.
				tcon_on_off(1);
				
				#if CONFIG_FASHION_STAR	
				//-- Backlight control by brightness
				tcon_set_brightness(1);
				BL_OUT;
				BL_ON;
				tcon_set_brightness(brightness);
				#else
				//-- Backlight control by pwm
				tcon_set_pwm(1);
				//-- Turn on pwm(backlight).
				tcon_pwm_on_off(1);
				tcon_backlight_on_off(1);
				tcon_set_pwm(brightness);
				#endif

			#else	//	~#if CONFIG_SKY_SPINOR_DRIVER
				#if CONFIG_SHOW_LOGO_FAST
				set_default_brightness_contrast();
				tcon_set_contrast(contrast);
				//-- Enable terawins output data.
				tcon_on_off(1);
					#if CONFIG_FASHION_STAR
					//-- Backlight control by brightness
					tcon_set_brightness(1);
					BL_OUT;
					BL_ON;
					tcon_set_brightness(brightness);
					#else	//	~#if CONFIG_FASHION_STAR
					//-- Backlight control by pwm
					tcon_set_pwm(1);
					//-- Turn on pwm(backlight).
					tcon_pwm_on_off(1);
					tcon_backlight_on_off(1);
					tcon_set_pwm(brightness);
					#endif	//	~#if CONFIG_FASHION_STAR	

				    #if CONFIG_SKY_IO_FOXCONN_COMPANY_V2_LCD
				    BL_OUT;
				    BL_ON;
				    #endif
                #else //MEL for PWM_1 enable
                    //tcon_set_pwm(1);
					//tcon_pwm_on_off(1);
					//tcon_backlight_on_off(1);
					//tcon_set_pwm(0xc8);
				#endif	//	~#if CONFIG_SHOW_LOGO_FAST
			
			#endif	//	~#if CONFIG_SKY_SPINOR_DRIVER
			
		#else	//	~#if CONFIG_TERAWINS_TCON
		BL_OUT;
		BL_ON;
		#endif	//#if CONFIG_TERAWINS_TCON
	}
	return 0;
}

/* -------------------------------------------------------------------------- */
int set_rgb_pointer(void)
{
	pgu_ptr->frm_start 	= FBBaseAddr;
	pgu_ptr->stride		= (p_current_display->xres) * 2;

	pgu_ptr->statctrl &= ~(STATCTRL_PIX_FMT_MASK);
	pgu_ptr->statctrl |= (STATCTRL_PIX_FMT_RGB555);

	return 0;
}
