/******************************************************************************
 * Copyright Codito Technologies (www.codito.com) Oct 01, 2004
 * 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 *****************************************************************************/


	/* /arch/arcnommu/kernel/head.S */

#include <linux/linkage.h>
#include <asm/arcregs.h>
#include <linux/config.h>
	.cpu A7
#ifdef CONFIG_KERNEL_ATAG
	.data
	.globl atag_head
	.align 4
atag_head:
		.long 0
#endif
	.section .text.init, "ax",@progbits
	.type stext, @function
	.globl stext
stext:
        sr	1,[0x47]	; Invalidate the data cache.

#ifdef CONFIG_KERNEL_ATAG
	;adding support for atag parsing 
	;If kernel parameters are passed by u-boot, then
	; r0 = 0
	; r1 = magic number (board identity)
	; r2 = address of ATAG parameter list 

	cmp	r0, 0x0
	jne	no_params
	lr	r3, [identity]
	cmp	r1, r3
	jne	no_params
	st	r2, [atag_head]

no_params:
#endif

#ifdef CONFIG_ARC700_CHANGE_CLK
        mov      r9,  0x70a309e3 

	mov      r4,  0x073f8001
        mov      r5,  0x00002000 
	#if (CONFIG_ARC700_CLK == 189000000)
              mov      r12, 0xc0001c0e
	#elif (CONFIG_ARC700_CLK == 162000000)
              mov      r12, 0xc0001c0c
	#elif (CONFIG_ARC700_CLK == 148500000)
              mov      r12, 0xc0001c0b 
	#elif (CONFIG_ARC700_CLK == 135000000)
              mov      r12, 0xc0001c0a
	#endif

        #if defined(CONFIG_ARC700_USE_SDRAM)
            st.di    r4, [0xc0fc1800]
            st.di    r4, [0xc0fc1800]

            __memdelay00:	
            sub.f    r5,  r5, 1	
            jnz __memdelay00	

	    mov     r4,  0xE0000000
            st.di   r4, [0xc0fc180c] 
	    mov     r4,  0xc0000000
            st.di   r4, [0xc0fc180c] 

	    st.di   r12, [0xc0fc180c]
            st.di   r12, [0xc0fc180c] 

	    mov r5, 0x50000
	    __memdelay01:
	    sub.f    r5,  r5, 1
	    jnz __memdelay01

	  #if (CONFIG_ARC700_CLK == 189000000)
            mov      r11, 0xc000100e
	  #elif (CONFIG_ARC700_CLK == 162000000)
            mov      r11, 0xc000100c 
	  #elif (CONFIG_ARC700_CLK == 148500000)
            mov      r11, 0xc000100b 
	  #elif (CONFIG_ARC700_CLK == 135000000)
            mov      r11, 0xc000100a 
	  #endif

	    st.di   r11, [0xc0fc180c]

            /* put something to UARX tx, good for clock change..... */
	    mov r2, 0x62
	    st.di r2, [0xc0fc1010]

	    mov r5, 0x10000
	    __memdelay02:
	    sub.f    r5,  r5, 1
	    jnz __memdelay02

          #if (CONFIG_ARC700_DIVCLK == 1)
            mov      r8,  0x00000001 
           #if defined(CONFIG_SKY_EVB_V2)
            mov      r6,  0x00000161 
            mov      r7,  0x01013131 
            mov     r10,  0x00040100 
           #elif defined(CONFIG_SKY_EVB_V1)
            mov      r6,  0x00000561 
            mov      r7,  0x05053737 
            mov     r10,  0x00040101 
           #elif defined(CONFIG_SKY_EVB_BIV1)
            mov      r6,  0x00000767 
            mov      r7,  0x07073737
            mov     r10,  0x00040101 
            mov      r9,  0x508209e3 
           #endif
          #else
            mov      r8,  0x00000005
           #if defined(CONFIG_SKY_EVB_V2)
            mov      r6,  0x00000161 
            mov      r7,  0x01013131 
            mov     r10,  0x00040100 
           #elif defined(CONFIG_SKY_EVB_V1)
            mov      r6,  0x00000561 
            mov      r7,  0x05053737 
            mov     r10,  0x00010101 
           #endif

          #endif
            mov r5, 0x00001000	
            st.di    r6, [0xc0fc1818] 
            st.di    r7, [0xc0fc1814] 
            __memdelay03:
            sub.f    r5,  r5, 1	
            jnz __memdelay03	
            st.di    r9, [0xc0fc7004]	
            st.di   r10, [0xc0fc7008]	
            st.di    r8, [0xc0fc700c]	
            mov r5, 0x00001000	
            __memdelay04:	
            sub.f    r5,  r5, 1	
            jnz __memdelay04
        #elif defined(CONFIG_ARC700_USE_DDR)
 /* DDR Setting */
            mov     r13,  0x91460480

            mov      r6,  0x00000121
            mov      r7,  0x01013131 
          #if defined(CONFIG_ARC700_DDR_16BIT)
            mov      r8,  0x002a1200
            mov      r9,  0x00000801 
            mov     r10,  0x124e6665 
          #else	/* DDR 32BIT */
           #if defined(CONFIG_ARC700_DDR_CL_3)	/* DDR 32BIT, CL=3 */
            mov      r8,  0x002a0200
            mov      r9,  0x00000801 
            mov     r10,  0x124f7777 
           #elif defined(CONFIG_ARC700_DDR_CL_25)	/* DDR 32BIT, CL=2.5 */
            mov      r8,  0x002a0200
            mov      r9,  0x00000810
            mov     r10,  0x124eeeee
           #elif defined(CONFIG_ARC700_DDR_CL_2)	/* DDR 32BIT, CL=2 */
;            mov      r8,  0x002a0200
            mov      r8,  0x00020200
;            mov      r9,  0x00000810
            mov      r9,  0x00000000
;            mov     r10,  0x124eeeee
            mov     r10,  0x0006EA46
           #endif
          #endif

          #if defined(CONFIG_ARC700_DDR_CL_25) || defined(CONFIG_ARC700_DDR_CL_2) /* DDR 32BIT, CL=2.5 */
            st.di   r13, [0xc0fca004]
          #endif
            st.di    r8, [0xc0fca00c]
            st.di    r9, [0xc0fca008]
            st.di   r10, [0xc0fca000]

            mov r5, 0x00030100	
            __memdelay1s:
            sub.f    r5,  r5, 1	
            jnz __memdelay1s

            mov r5, 0x00030100	

            st.di    r4, [0xc0fc1800]
            st.di    r4, [0xc0fc1800]

            __memdelay10:	
            sub.f    r5,  r5, 1	
            jnz __memdelay10	
            mov r5, 0x00030100
            st.di    r6, [0xc0fc1818] 
            st.di    r7, [0xc0fc1814] 
            __memdelay13:
            sub.f    r5,  r5, 1	
            jnz __memdelay13
            mov r5, 0x00000100	
            __memdelay14:
            sub.f    r5,  r5, 1	
            jnz __memdelay14
         #endif

        #endif	//-- end of USE SDRAM/DDR

	sr	1,[0x47]	; Invalidate the data cache.
 	mov_s	r2, _bss_start 	; Clear down the BSS


//#ifdef CONFIG_ARC_CMDLINE
#if 0
	ldw	r0,[r2,0]	; Leave the command in place, if we're using it.
	add	r2,r2,r0	; Command format is 2-bytes string length at _bss_start, followed by the command string
	add	r2,r2,2
	mov	r3,r2
	and	r2,r2,0xfffffffc
	add	r2,r2,4
__clear_word:
	stb.ab	0, [r3,1]
	brlt	r3,r2,__clear_word
#endif

	mov_s	r3, _bss_end
__clear_bss:	
  	st.ab	0, [r2,4]
  	brlt	r2, r3, __clear_bss

//#ifdef CONFIG_ARC_CMDLINE
#if 0
	mov_s	r2, _bss_start	;  Copy the command passed in via BSS
	ldw	r0,[r2,0]
        stw	0,[r2,0]
	tst	r0,0xffffffff
	jz	__cmddone
	mov_s	r3, command_line
	add	r2,r2,2

__cmdloop:
	ldb	r4,[r2]
	stb.ab  0,[r2,1]
	stb.ab	r4,[r3,1]
	
	sub.f	r0,r0,1
	jnz	__cmdloop
		
__cmddone:
#endif
	
	
; 	lr	r1,[identity]
; 	and	r2, r1, 0x000000ff   ;store in r2 the processor version
	
; 	asr	r1, r1, 8
; 	and	r1, r1, 0x000000ff     ;store in r3 the processor id  

; 	st	r2, [processor_version]
; 	st	r1, [processor_id]

	mov	fp, 0
;	mov 	sp,init_task_union + 8192
;	mov 	sp, 0x00020000 + 8192
#if CONFIG_SRAM_SIZE >= 0x04000000
	mov 	sp, 0x03fa0000 + 8192
#elif CONFIG_SRAM_SIZE >= 0x02000000
	mov 	sp, 0x01fa0000 + 8192
#else
	mov 	sp, 0x00fa0000 + 8192
#endif

  /* Jump to start of kernel initialization routine */
	jal start_kernel

