#ifndef SKY_8850_DMA_H_
#define SKY_8850_DMA_H_

#define REG_R32(reg)						(*((volatile unsigned int*)(reg)))
#define REG_W32(reg, data)					(*((volatile unsigned int*)(reg)) = (data))

#define DMA_BASE_ADDR						0xc1fc1000
#define DMA_R32(reg)						(REG_R32((DMA_BASE_ADDR+reg)))
#define DMA_W32(reg, val)					(REG_W32((DMA_BASE_ADDR+reg), val))

typedef enum _DMA_REGS{
	DMA_CONFIG = 0x00,
	DMA_SRC_ADDR = 0x04,
	DMA_DEST_ADDR = 0x08,
	DMA_BYTE_SIZE = 0x0C,
}DMA_REGS;

#define DMA_INT_NUM							11
#define DMA_MAX_LEN							(1<<17) /* 128KB */

#define DMA_CLEAR_DIRECTION                 0xFFFFFF00 
#define DMA_SOURCE_SRAM                     0x00000000
#define DMA_SOURCE_CR_BANK                  0x00000001
#define DMA_SOURCE_I2S_AD                   0x00000002
#define DMA_SOURCE_USB_FIFO0                0x00000003
#define DMA_TARGET_SRAM                     0x00000000
#define DMA_TARGET_CR_BANK                  0x00000010
#define DMA_TARGET_I2S_AD                   0x00000020
#define DMA_TARGET_USB_FIFO0                0x00000030

void dma_sram_to_i2s(unsigned int src_addr, unsigned int size);

#endif /*SKY_8850_DMA_H_*/
