#include "sky_8850_i2s.h"
#include "sky_8850_dma.h"

void i2s_set_power(int power)
{
	if(power){
		I2S_IF_ENABLE;
	}else{
		I2S_DATA_INT_OFF;

		I2S_DATA_TRAN_OFF;

		I2S_IF_DISABLE;
	}
}

/* ---------------------------------------------------- */

void i2s_init(unsigned int audio_stream, unsigned int audio_size)
{
	/* config I2S PLL clk */
	AUDIO_PLL_SET(AUDIO_PLL_49MHZ);	
	/* set I2S word length */
	I2S_WORD_LEN(WORD_LEN_32);
	/* set I2S sample rate */
	I2S_SET_SAMPLE_RATE(I2S_8000HZ_MCD, I2S_8000HZ_SCD);
	/* enable I2S device */
	//MEL from: nelly modify 9/24/2008
	//I2S_IF_ENABLE;
	/* start DMA to I2S FIFO */
//	dma_sram_to_i2s(0x100000, DMA_MAX_LEN);
//	dma_sram_to_i2s(audio_stream, DMA_MAX_LEN);
	if (audio_size > DMA_MAX_LEN)
	{
		audio_size = DMA_MAX_LEN;
	}
	//MEL from:nelly modify 9/24/2008
	//dma_sram_to_i2s(audio_stream, audio_size);
	/* I2S start transmit */
	//MEL from:nelly modify 9/24/2008
	//I2S_DATA_TRAN_ON;
	/* I2S stop transmit */
//	I2S_DATA_TRAN_OFF;
}

/* ---------------------------------------------------- */
/*
int main(char argc, char* argv[])
{	
	i2s_init();
	return 1;
}
*/
