
#ifndef __DISP_PARAM_H__
#define __DISP_PARAM_H__

#include "arc_pgu.h"
#include "arc_tcon.h"
#include <linux/autoconf.h>

//-- Display configuration
struct known_displays
{
	unsigned long xres;
	unsigned long yres;
	unsigned long bpp;
	unsigned char display_name[64];
	unsigned long control;
	unsigned long clkcontrol;
	unsigned long hsync;
	unsigned long vsync;
};

//-- Display index.
enum DisplayIndex
{
	DISP_NTSC = 0,			// 0
	DISP_PAL,				// 1
	DISP_HDTV,				// 2
	DISP_1024x600_LCD,		// 3
	DISP_800x480_LCD,		// 4
	DISP_800x600_LCD,		// 5
	DISP_1366x768_LCD,		// 6
	DISP_640x480_LCD,		// 7
	DISP_800x480_LCD_25MHZ,	// 8
	DISP_HIMAX_480240_TFT,	// 9
	DISP_HIMAX_NTSC,		// a
	DISP_HIMAX_PAL,			// b
	DISP_MAX,				// c
};

//-- T-CON functions.
#ifdef CONFIG_TERAWINS_TCON
#define tcon_set_command(_dev, _reg, _data)	terawins_set_cmd(_dev, _reg, _data)
#define tcon_set_osd_cmd(_idx, _data)		terawins_set_osd_cmd(_idx, _data)
#define tcon_set_osd_ram_addr(_addr)		terawins_set_osd_ram_addr(_addr)
#define tcon_set_osd_ram_data(_data)		terawins_set_osd_ram_data(_data)
#define tcon_set_osd_line_data(_addr, _str)	terawins_set_osd_line_data(_addr, _str)
#define tcon_set_resolution(_idx)			terawins_set_resolution(_idx)
#define tcon_on_off(_on)					terawins_on_off(_on)
#define tcon_clear_all_osd_item()			terawins_clear_all_osd_item()
#define init_tcon()							init_terawins_tcon()
#define init_tcon_osd()						init_terawins_osd()
#define tcon_pwm_on_off(_on)				terawins_pwm_on_off(_on)
#define tcon_backlight_on_off(_on)			terawins_backlight_on_off(_on)
#define tcon_set_pwm(_val)					terawins_set_pwm(_val)
#define tcon_set_brightness(_val)			terawins_set_brightness(_val)
#define tcon_set_contrast(_val)				terawins_set_contrast(_val)
#define tcon_parse_resolution(_w, _h)		terawins_parse_resolution(_w, _h)

//-- OSD function
#define tcon_show_icon(_idx)				terawins_show_icon(_idx)
#define tcon_clear_icon()					terawins_clear_icon()
#define tcon_show_subtitle(_s)				terawins_show_subtitle(_s)
#define tcon_clear_subtitle()				terawins_clear_subtitle()
#define tcon_show_mute_vol(_idx)			terawins_show_mute_vol(_idx)
#define tcon_clear_mute_vol()				terawins_clear_mute_vol()
#define tcon_show_time(_t)					terawins_show_time(_t)
#define tcon_clear_time()					terawins_clear_time()
#define tcon_show_speed(_t)					terawins_show_speed(_t)
#define tcon_clear_speed()					terawins_clear_speed()
#define tcon_set_time_on_off(_on)			terawins_set_time_on_off(_on)
#define tcon_get_time_on_off()				terawins_get_time_on_off()

#else	//~ CONFIG_TERAWINS_TCON
#define tcon_set_command(_dev, _reg, _data)
#define tcon_set_osd_cmd(_idx, _data)
#define tcon_set_osd_ram_addr(_addr)
#define tcon_set_osd_ram_data(_data)
#define tcon_set_osd_line_data(_addr, _str)
#define tcon_set_resolution(_idx)
#define tcon_on_off(_on)
#define tcon_clear_all_osd_item()
#define init_tcon()
#define init_tcon_osd()
#define tcon_pwm_on_off(_on)
#define tcon_backlight_on_off(_on)
#define tcon_set_pwm(_val)
#define tcon_set_brightness(_val)
#define tcon_set_contrast(_val)

//-- OSD function
#define tcon_show_icon(_idx)
#define tcon_clear_icon()
#define tcon_show_subtitle(_s)
#define tcon_clear_subtitle()
#define tcon_show_mute_vol(_idx)
#define tcon_clear_mute_vol()
#define tcon_show_time(_t)
#define tcon_clear_time()
#define tcon_show_speed(_t)
#define tcon_clear_speed()
#define tcon_set_time_on_off(_on)
#define tcon_get_time_on_off()


#endif	//~ CONFIG_TERAWINS_TCON

extern struct known_displays displays[DISP_MAX];

#endif	//~ __DISP_PARAM_H__

