
/* pci.h */

/*
 * Mercifully, we don't have PCI on ARC. Don't tell the kernel, though.
 */

#ifndef __ASMARC_PCI_H
#define __ASMARC_PCI_H

#ifdef __KERNEL__

#define PCI_DMA_BUS_IS_PHYS			(0)
#define PCIBIOS_MIN_IO		0xC1FC0000
#define PCIBIOS_MIN_MEM		0xC1FC0000

static inline void pcibios_set_master(struct pci_dev *dev)
{
	/* No special bus mastering setup handling */
}

static inline void pcibios_penalize_isa_irq(int irq)
{
	/* We don't do dynamic PCI IRQ allocation */
}

#define pcibios_scan_all_fns()		0

struct pci_dev;
struct scatterlist;

extern void *pci_alloc_consistent(struct pci_dev *hwdev, size_t size, dma_addr_t *handle);

extern void
pci_free_consistent(struct pci_dev *hwdev, size_t size, void *vaddr,
				dma_addr_t dma_handle);

static inline dma_addr_t
pci_map_single(struct pci_dev *hwdev, void *ptr, size_t size, int direction)
{
	return (dma_addr_t)NULL;
}

static inline void
pci_unmap_single(struct pci_dev *hwdev, dma_addr_t dma_addr, size_t size, int direction)
{
	/* nothing to do */
}

static inline int
pci_map_sg(struct pci_dev *hwdev, struct scatterlist *sg, int nents, int direction)
{
	return 0;
}

static inline void
pci_unmap_sg(struct pci_dev *hwdev, struct scatterlist *sg, int nents, int direction)
{
	/* nothing to do */
}

static inline void
pci_dma_sync_single(struct pci_dev *hwdev, dma_addr_t dma_handle, size_t size, int direction)
{
}

static inline void
pci_dma_sync_sg(struct pci_dev *hwdev, struct scatterlist *sg, int nelems, int direction)
{
}

static inline int pci_dma_supported(struct pci_dev *hwdev, u64 mask)
{
	return 0;
}

#define pci_dac_dma_supported(pci_dev, mask)	(0)
#define pci_controller_num(PDEV)	(0)

#endif
#endif
